#pragma once

#include <RobotAPI/interface/objectpose/ObjectPoseStorageInterface.h>
#include <RobotAPI/libraries/ArmarXObjects/ObjectFinder.h>
#include <RobotAPI/libraries/ArmarXObjects/ObjectPose.h>


namespace armarx::objpose
{

    /**
     * @brief Provides access to the `armarx::objpose::ObjectPoseStorageInterface`
     * (aka the object memory).
     */
    class ObjectPoseClient
    {
    public:

        ObjectPoseClient();
        ObjectPoseClient(const ObjectPoseStorageInterfacePrx& objectPoseStorage,
                         const ObjectFinder& finder = {});

        void connect(const ObjectPoseStorageInterfacePrx& objectPoseStorage);

        bool isConnected() const;


        ObjectPoseSeq
        fetchObjectPoses();

        ObjectPoseMap
        fetchObjectPosesAsMap();

        ObjectPoseSeq
        fetchObjectPosesFromProvider(const std::string& providerName);


        const ObjectPoseStorageInterfacePrx&
        getObjectPoseStorage() const;

        const ObjectFinder&
        getObjectFinder() const;


    public:

        ObjectPoseStorageInterfacePrx objectPoseStorage;

        ObjectFinder objectFinder;

    };

}
