#pragma once

// Base Class
#include "../Converter.h"

// ArmarX
#include "../json/JsonConverter.h"

namespace armarx::armem::server::ltm::converter::dict
{
    class BsonConverter;
    using BsonConverterPtr = std::shared_ptr<BsonConverter>;

    class BsonConverter : public DictConverter
    {
    public:
        BsonConverter() :
            DictConverter(ConverterType::Binary, ".bson")
        {}

        virtual std::vector<unsigned char> convert(const aron::data::DictPtr& data) override;
        virtual aron::data::DictPtr convert(const std::vector<unsigned char>& data) override;

    private:
        JsonConverter jsonConverter;
    };
}
