#include "armarx.h"


#include <RobotAPI/libraries/aron/common/aron_conversions/core.h>
#include <RobotAPI/libraries/aron/common/aron_conversions/stl.h>

namespace armarx
{

    /* PackagePath */

    void fromAron(const arondto::PackagePath& dto, PackagePath& bo)
    {
        bo = {dto.package, dto.path};
    }

    void toAron(arondto::PackagePath& dto, const PackagePath& bo)
    {
        const data::PackagePath icedto = bo.serialize();
        dto.package                    = icedto.package;
        dto.path                       = icedto.path;
    }

    void fromAron(const long& dto, IceUtil::Time& bo)
    {
        bo = IceUtil::Time::microSeconds(dto);
    }

    void toAron(long& dto, const IceUtil::Time& bo)
    {
        dto = bo.toMicroSeconds();
    }

} // namespace armarx
