#pragma once

#include "../Skill.h"

namespace armarx
{
    namespace skills::helper
    {
        class LambdaSkill : public Skill
        {
        public:
            using FunT = std::function<bool(const aron::data::DictPtr&)>;

            LambdaSkill() = delete;
            LambdaSkill(const FunT& f, const SkillDescription& desc) :
                Skill(desc),
                fun(f)
            {};

        protected:
            Skill::Status _execute(const aron::data::DictPtr& data, const CallbackT& callback = [](const aron::data::DictPtr& returnValue) { (void) returnValue; }) override;

        private:
            FunT fun;
        };
    }
}
